<template>
<div>
  <d-modal v-if="showModal" @close="handleClose">
    <d-modal-header>
        <d-modal-title>Create invite</d-modal-title>
    </d-modal-header>
    <d-modal-body style="padding: 5px 0">
      <div class="d-flex align-items-center justify-content-center" style="height: 400px" v-if="getOptionsProcess">
        <b-spinner variant="primary"/>
      </div>
      <div class="custom__modal" v-if="!getOptionsProcess">
        <d-list-group flush class="custom__modal__container">
          <d-list-group-item class="p-3">
            <d-form @submit.prevent="createInvite" class="custom__modal__form">
              <input-element v-for="(element, index) in optionsToRenderFromEdit"
              :input-data="element"
              :input-id="index"
              :errors="errorMessages"
              :key="element.id"
              :value="createInviteData"
              :input="setDataField"
              />
              <div v-if="!createInviteProcess" class="d-flex justify-content-between">
                <d-button type="submit" name="submit" theme="primary">Create invite</d-button>
                <d-button type="button" name="cancel" class="btn-white" @click="handleClose">Cancel</d-button>
              </div>
            </d-form>
            <div class="text-center" v-show="createInviteProcess">
              <b-spinner variant="primary" label="Text Centered"/>
            </div>
          </d-list-group-item>
        </d-list-group>
      </div>
    </d-modal-body>
  </d-modal>
</div>
</template>

<script>
import { mapState } from 'vuex';
import { modalIsOpenWatcher } from '@/mixins';
import { OPTIONS_API_TO_WRITE_INVITE } from '@/store/apiConstants';
import { ADMIN_STORE, GET_OPTIONS_TO_WRITE_INVITE, SET_REGISTRATION_ERROR, CREATE_INVITE } from '@/store/adminStore/types';
import InputElement from '@/components/formElements/InputElement.vue';


export default {
  name: 'invite-create',
  components: {
    InputElement,
  },
  mixins: [modalIsOpenWatcher],
  data() {
    return {
      getOptionsProcess: false,
      createInviteProcess: false,
      queryParam: {},
      createInviteData: {},
      showModal: false,
    };
  },
  methods: {
    setDataField(data, inputId) {
      this.createInviteData[inputId] = data;
    },
    handleClick(queryParam) {
      this.getOptionsProcess = true;
      this.queryParam = queryParam;
      this.showModal = true;
      this.$store.dispatch(ADMIN_STORE + GET_OPTIONS_TO_WRITE_INVITE, OPTIONS_API_TO_WRITE_INVITE).then(() => {
        this.getOptionsProcess = false;
      });
    },
    handleClose() {
      if (this.createInviteProcess) return;
      this.$store.commit(ADMIN_STORE + SET_REGISTRATION_ERROR, {});
      this.createInviteData = {};
      this.queryParam = {};
      this.showModal = false;
    },
    createInvite() {
      this.createInviteProcess = true;
      const { createInviteData, queryParam } = this;
      const inviteDataObj = this.$copyObjectToSendData(createInviteData);
      inviteDataObj.group = 'user';
      this.$store.dispatch(ADMIN_STORE + CREATE_INVITE, { inviteDataObj, queryParam })
        .then((listPageToView) => {
          this.$parent.totalPagesCount = listPageToView;
          this.createInviteProcess = false;
          this.handleClose();
        }).catch(() => {
          this.createInviteProcess = false;
        });
    },
  },
  computed: {
    ...mapState(ADMIN_STORE, ['errorMessages', 'optionsToRenderFrom']),
    optionsToRenderFromEdit() {
      const optionsToRenderFromEdit = this.optionsToRenderFrom;
      delete optionsToRenderFromEdit.status;
      delete optionsToRenderFromEdit.group;
      return optionsToRenderFromEdit;
    },
  },
};
</script>
